Const NIX		:Int = 0		'Fr den Inhalt der Felder
Const SBLOCK	:Int = 1		'einfacher zu merken als pure Zahlen
Const BOMBE	:Int = 5
Const HBLOCK	:Int = 10

Type TKarte

	Field Feld		:TFeld[,] 'Dynamisches Array fr die Map, damit keine Grenbeschrnkungen entstehen
	Field MX			:Int 'Breite der Map
	Field MY			:Int 'Hhe der Map
	
	
	Method Zeichnen()
		For Local Y:Int=1 To MX
			For Local X:Int=1 To MY
				Feld[X,Y].Update() 'Aktuelles Feld auf Richtigkeit prfen
				Feld[X,Y].Zeichnen(X,Y) 'bergibt X und Y Werte an Feld.Zeichnen
			Next
		Next
	End Method
	
	Function Erstellen:TKarte(MX:Int,MY:Int,Boden:Int,HardBl:Int,SoftBl:Int)
		Local NeueMap:TKarte = New TKarte 'hier  wird die neue Map erstmal Temporr gespeichert
		
		NeueMap.Feld=New TFeld[MX+1,MY+1] 'Map Dimensionieren
		NeueMap.MX=MX 'Breite der Map speichern
		NeueMap.MY=MY 'Hhe der Map speichern
		'#############################################
		'#		STANDARTMAP ERSTELLEN			#
		'#############################################
		For Local Y:Int=1 To MY 		'jedes Feld von 1 bis zur Hhe der Map
			For Local X:Int=1 To MX 	'jedes Feld von 1 bis zur Breite der Map
				NeueMap.Feld[X,Y] = TFeld.Erstellen(Boden) 	'die einzelnen Felder werden erstellt
													'siehe TFeld.Erstellen Funktion
				If X=1 Or Y=1 Or X=MX Or Y=MY Then 
					NeueMap.Feld[X,Y].BlockTile	=HardBl
					NeueMap.Feld[X,Y].Inhalt 	=HBLOCK
				End If
				'haben X oder Y eine Wert, welcher den Rand der Map darstellt, so wird das
				'BlockTile auf einen HardBlock gesetzt. Auf diese Weise zeichne ich den Rand
				'der Map
				
				If X=3 Or X=5 Or X=7 Or X=9 Or X=11 Or X=13 Then
					If Y=3 Or Y=5 Or Y=7 Or Y=9 Or Y=11 Or Y=13 Then
						NeueMap.Feld[X,Y].BlockTile	=HardBl
						NeueMap.Feld[X,Y].Inhalt 	=HBLOCK
					End If
				End If
				'haben der X und der Y Wert eine Position erreicht, die wichtig fr das
				'Schachbretthnliche Muster sind, so wird ebenfalls ein HardBlock an die
				'Position gesetzt
			Next
		Next
		'#############################################
		'#	MAP MIT 100 SOFTBLCKEN FLLEN		#
		'#	DABEI SPIELER-STARTECKEN FREI LASSEN	#
		'#############################################
		Local BlockZahl:Int = 100	'100 Softblcke sollen gesetzt werden
		Repeat					'eine Schleife, die solange luft, bis 100 SoftBlcke gesetzt worden sind
			For Local Y:Int=1 To MY		'ich gehe wieder die ganze Map durch
				For Local X:Int=1 To MX
					Local Check:Int=0	'setze Check auf 0
					If Y=2 Or Y=3 Or Y=MY-2 Or Y=MY-1 Then Check:+1		'fr die StartEcken
					If X=2 Or X=3 Or X=MX-2 Or X=MX-1 Then Check:+1		'wie zuvor beschrieben
					If BlockZahl=0 Or (Y=8 And X=8) Then Check=2
					'habe ich schon 100 Blcke gesetzt ODER ist das aktuelle Feld grade die Mitte
					'Dann Check auf 2 setzen, damit kein Block gesetzt wird.
					If Check<2 Then
						If NeueMap.Feld[X,Y].BlockTile=0 And Rand(0,2)=1 Then
						'wenn auf aktuellem Feld noch kein Block ist und Rand(0,2)=1 dann neuen Block setzen
							NeueMap.Feld[X,Y].BlockTile	=SoftBl
							NeueMap.Feld[X,Y].Inhalt		=SBLOCK
							BlockZahl:-1 'gesetzten Block abziehen (denn ich will ja nur 100 haben)
						End If
					End If
				Next
			Next
		Until (BlockZahl=0) 'wenn 100 Softblcke gesetzt wurden Schleife verlassen und Map zurck geben.
		Return NeueMap	 'hiermit gebe ich die temporr erstellte Map zurck
	End Function

End Type 